%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018-2019  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function DB_Node_Edit_Coord(Node_list, New_Reference_Coord, New_Analysis_Coord)

global ErrCode;

global DB_NODES;
global DB_COORD;
global AST_COORD;

global AT_NODES;
global AT_COORD;

global Cylindrical_CID_R_Tolerance;

Node_list = unique(Node_list);

% Проверка существования в базе узлов
for i=1:size(Node_list,1)
    if (~DB_Node_Exist(Node_list(i)))
        fprintf (1, '\nОшибка функции DB_Node_Edit_Coord: узел с номером %i отсутствует в базе !\n', Node_list(i));
        ErrCode = -1;
        return;
    end
end

% Проверка существования в базе референсной системы координат
if (~isempty(New_Reference_Coord))
    if (New_Reference_Coord ~= 0)
        if (~DB_Coord_Exist(New_Reference_Coord))
            fprintf (1, '\nОшибка функции DB_Node_Edit_Coord: референсная система координат с номером %i отсутствует в базе !\n', New_Reference_Coord);
            ErrCode = -1;
            return;
        end
    end
end

% Проверка существования в базе системы координат анализа
if (~isempty(New_Analysis_Coord))
    if (New_Analysis_Coord ~= 0)
        if (~DB_Coord_Exist(New_Analysis_Coord))
            fprintf (1, '\nОшибка функции DB_Node_Edit_Coord: система координат анализа с номером %i отсутствует в базе !\n', New_Analysis_Coord);
            ErrCode = -1;
            return;
        end
    end
end

% Если обе системы координат в аргументах пустые, то никаких изменений не требуется
if (isempty(New_Reference_Coord) && isempty(New_Analysis_Coord))
    return;
end

% Внесение изменений в таблицу ассоциативности систем координат
for i=1:size(Node_list,1)
    
    % Локальный список новых систем координат, включающий системы координат, остающиеся без изменения
    if (isempty(New_Reference_Coord))
        New_Local_Reference_Coord = DB_NODES{AT_NODES(Node_list(i))}.Reference_CID;
    else
        New_Local_Reference_Coord = New_Reference_Coord;
    end
    
    if (isempty(New_Analysis_Coord))
        New_Local_Analysis_Coord = DB_NODES{AT_NODES(Node_list(i))}.Analysis_CID;
    else
        New_Local_Analysis_Coord = New_Analysis_Coord;
    end
    
    New_Coord_list = Union_Column(New_Local_Reference_Coord, New_Local_Analysis_Coord);
    New_Coord_list = setdiff(New_Coord_list, 0);
    if (isempty(New_Coord_list))
        New_Coord_list = [];
    end
    
    % Список старых систем координат
    Old_Coord_list = Union_Column(DB_NODES{AT_NODES(Node_list(i))}.Reference_CID, DB_NODES{AT_NODES(Node_list(i))}.Analysis_CID);
    Old_Coord_list = setdiff(Old_Coord_list, 0);
    if (isempty(Old_Coord_list))
        Old_Coord_list = [];
    end
    
    % Списки добавления и удаления
    Add_Coord_list = setdiff(New_Coord_list, Old_Coord_list);
    Remove_Coord_list = setdiff(Old_Coord_list, New_Coord_list);
    
    % Внесение изменений в таблицу ассоциативности
    if (~isempty(Remove_Coord_list))
        for j=1:size(Remove_Coord_list,1)
            AST_COORD{AT_COORD(Remove_Coord_list(j))}.Node_list = setdiff(AST_COORD{AT_COORD(Remove_Coord_list(j))}.Node_list, Node_list(i));
            if (isempty(AST_COORD{AT_COORD(Remove_Coord_list(j))}.Node_list))
                AST_COORD{AT_COORD(Remove_Coord_list(j))}.Node_list = [];
            end
        end
    end

    if (~isempty(Add_Coord_list))
        for j=1:size(Add_Coord_list,1)
            AST_COORD{AT_COORD(Add_Coord_list(j))}.Node_list = Union_Column(AST_COORD{AT_COORD(Add_Coord_list(j))}.Node_list, Node_list(i));
        end
    end

end

% Модификация записей в базе
for i=1:size(Node_list,1)
    
    % Модификация системы координат анализа
    if (~isempty(New_Analysis_Coord))
    
        DB_NODES{AT_NODES(Node_list(i))}.Analysis_CID = New_Analysis_Coord;
    
    end
    
    % Модификация референсной системы координат
    if (~isempty(New_Reference_Coord))
        
        if (New_Reference_Coord ~= DB_NODES{AT_NODES(Node_list(i))}.Reference_CID)

            if (New_Reference_Coord == 0)

                DB_NODES{AT_NODES(Node_list(i))}.Ref_Location = DB_NODES{AT_NODES(Node_list(i))}.Location;

            else

                switch DB_COORD{AT_COORD(New_Reference_Coord)}.type

                    case 'Rectangular'

                        Local_XYZ = [DB_COORD{AT_COORD(New_Reference_Coord)}.e_x, DB_COORD{AT_COORD(New_Reference_Coord)}.e_y, DB_COORD{AT_COORD(New_Reference_Coord)}.e_z] \ (DB_NODES{AT_NODES(Node_list(i))}.Location - DB_COORD{AT_COORD(New_Reference_Coord)}.origin);
                        DB_NODES{AT_NODES(Node_list(i))}.Ref_Location = Local_XYZ;

                    case 'Cylindrical'

                        Local_XYZ = [DB_COORD{AT_COORD(New_Reference_Coord)}.e_r, DB_COORD{AT_COORD(New_Reference_Coord)}.e_t, DB_COORD{AT_COORD(New_Reference_Coord)}.e_z] \ (DB_NODES{AT_NODES(Node_list(i))}.Location - DB_COORD{AT_COORD(New_Reference_Coord)}.origin);

                        DB_NODES{AT_NODES(Node_list(i))}.Ref_Location(1) = norm(Local_XYZ(1:2));

                        if (DB_NODES{AT_NODES(Node_list(i))}.Ref_Location(1) < Cylindrical_CID_R_Tolerance)
                            DB_NODES{AT_NODES(Node_list(i))}.Ref_Location(2) = 0;
                        else
                            DB_NODES{AT_NODES(Node_list(i))}.Ref_Location(2) = acosd(Local_XYZ(1) / DB_NODES{AT_NODES(Node_list(i))}.Ref_Location(1));
                            if (Local_XYZ(2) < 0)
                                DB_NODES{AT_NODES(Node_list(i))}.Ref_Location(2) = -DB_NODES{AT_NODES(Node_list(i))}.Ref_Location(2);
                            end
                        end

                        DB_NODES{AT_NODES(Node_list(i))}.Ref_Location(3) = Local_XYZ(3);

                    otherwise

                        fprintf (1, '\nОшибка функции DB_Node_Edit_Coord: тип [%s] системы координат с номером %i не поддерживается в текущей версии программы !\n', DB_COORD{AT_COORD(New_Reference_Coord)}.type, DB_COORD{AT_COORD(New_Reference_Coord)}.ID);
                        fprintf (1, 'Обратитесь к разработчику для решения данного вопроса.\n');
                        ErrCode = -1;
                        return;

                end

            end

            DB_NODES{AT_NODES(Node_list(i))}.Reference_CID = New_Reference_Coord;

        end
    
    end
    
end
